import org.python.core.*;
import org.python.util.*;
import java.net.*;
import java.io.*;
import java.util.*;

public class ClassLoaderBug
{

	private static String testCode = 
		"import sys, os.path, shutil\n" +
		"from java.lang import System\n" +

		"testClass = 'sun.plugin.converter.ResourceHandler'\n" +
		"testJar = System.getProperty('java.home') + '/../lib/htmlconverter.jar'\n" +
		"testJarCopy = os.path.basename(testJar)\n" +
		"shutil.copyfile(testJar, testJarCopy)\n" +
		
		"print 'sys ID:', id(sys)\n" +
		"print 'sys.classLoader ID:', id(sys.classLoader)\n" +
		"print 'sys.packageManager ID:', id(sys.packageManager)\n" +
		"sys.classLoader.addJar(testJar)\n" +
		"import sun.plugin.converter.ResourceHandler\n" +
		"print 'class: ', sun.plugin.converter.ResourceHandler\n" +
		"print 'class ID: ', id(sun.plugin.converter.ResourceHandler)\n";
		

	public static class PythonCL extends URLClassLoader
	{
		private SysPackageManager pm;

		public PythonCL(SysPackageManager pm)
		{
			super(new URL[0]);
			this.pm = pm;
		}
		public void addJar(String jarfile) throws Exception
		{
			File file = new File(jarfile);
			super.addURL(file.toURL());
			pm.addJar(file.getCanonicalPath(), true);
		}
	}
	
	public static void main(String[] args) throws Exception
	{
		PythonInterpreter.initialize(System.getProperties(), new Properties(), new String[0]);

		System.out.println("Running in main thread:\n\n");
		PySystemState sys =new PySystemState();
		sys.setClassLoader(new PythonCL((SysPackageManager) sys.packageManager));
		PythonInterpreter interp = new PythonInterpreter(new PyStringMap(), sys);
		interp.exec(testCode);

		Thread t = new Thread(new Runnable() {
				public void run()
				{
					PySystemState sys =new PySystemState();
					sys.setClassLoader(new PythonCL((SysPackageManager) sys.packageManager));
					PythonInterpreter interp2 = new PythonInterpreter(new PyStringMap(), sys);
					interp2.exec(testCode);
				}
			});

		System.out.println("\nRunning in another thread:\n\n");
		t.start();
		t.join();
	}

}

 	  	 
